<?php
// prevent sql injection
function quote_smart($value)
{
	if( is_array($value) ) 
	{
		return array_map("quote_smart", $value);
	}
	
	else 
	{
		if( get_magic_quotes_gpc() ) 
		{
			$value = stripslashes($value);
		}
        	
        	if( !is_numeric($value) || $value[0] == '0' ) 
        	{
        		// we also don't want nasty html, for usernames and such
        		$value = htmlentities($value);
        		
        		// we also don't want a blank value
        		$value = trim($value);
        		
				$value = mysql_real_escape_string($value);
        	}
        	
        	return $value;
	}
}

function check_email_address($email) 
{
	// First, we check that there's one @ symbol, and that the lengths are right
	if (!ereg("^[^@]{1,64}@[^@]{1,255}$", $email)) 
	{
		// Email invalid because wrong number of characters in one section, or wrong number of @ symbols.
		return false;
	}
	
	// Split it into sections to make life easier
	$email_array = explode("@", $email);
	$local_array = explode(".", $email_array[0]);
	for ($i = 0; $i < sizeof($local_array); $i++) 
	{
		if (!ereg("^(([A-Za-z0-9!#$%&'*+/=?^_`{|}~-][A-Za-z0-9!#$%&'*+/=?^_`{|}~\.-]{0,63})|(\"[^(\\|\")]{0,62}\"))$", $local_array[$i]))
		{
			return false;
		}
	}
	
	if (!ereg("^\[?[0-9\.]+\]?$", $email_array[1]))
	{ 
		// Check if domain is IP. If not, it should be valid domain name
		$domain_array = explode(".", $email_array[1]);
		if (sizeof($domain_array) < 2)
		{
			return false; // Not enough parts to domain
		}
		
		for ($i = 0; $i < sizeof($domain_array); $i++) 
		{
			if (!ereg("^(([A-Za-z0-9][A-Za-z0-9-]{0,61}[A-Za-z0-9])|([A-Za-z0-9]+))$", $domain_array[$i])) 
			{
				return false;
			}
		}
	}
	return true;
}

function get_template($template_name, $block='')
{	
	if (empty($block))
	{
		$tn = 'templates/' . $template_name . '.html';
	
		if (file_exists($tn))
		{
			$t = file_get_contents($tn);		
			return "return <<<TMP\r\n\r\n<!-- begin ".$template_name." -->\n".$t."\r\n\r\n<!-- end ".$template_name." -->\nTMP;\r\n";
		}
	
		else
		{
			die('Error template not found!');
		}
	}
	
	else
	{
		$tn = 'templates/' . $template_name . '.html';
	
		if (file_exists($tn))
		{
			$t = file_get_contents($tn);		
			
			$pattern = '#\[block:\s*(' . $block . ')\](.*)\[/block:\s*(\1)\]#is'; 
			
			// find the wanted part of the template
			preg_match($pattern, $t, $matches);
			
			// return the contents to be evaled and echod out
			return "return <<<TMP\r\n\r\n<!-- start template ".$template_name." --><!-- start block -->\n".$matches[2]."\r\n\r\n<!-- end block --><!-- end template ".$template_name." -->\nTMP;\r\n";
		}
	
		else
		{
			error_message('Error template not found!');
			
			die();
		}
	}
}

function error_message($message)
{
	$error_message = $message;
	echo eval(get_template('error'));
	
	include('footer.php');
	
	die();
}

function message($message)
{
	echo eval(get_template('message'));
}

// check permissions via the forum_id and what they are trying to do, also if you want the error message to be output
// error message can be turned off for further options, for example keeping users out but admins in
function permissions($trying,$forum_id,$error=1)
{	
	$forum_id = quote_smart($forum_id);
	$group_sql = quote_smart($_SESSION['group']);
	
	if ($trying == 'viewforum')
	{
		$sql_permissions = "SELECT `can_view`,`can_topic` FROM `permissions` WHERE `forum_id` = {$forum_id} AND `group_id` = {$group_sql}";
		
		$query_permissions = mysql_query($sql_permissions) or die(mysql_error() . '<br />Sql: ' . $sql_permissions);
		
		$permission = mysql_fetch_array($query_permissions);
		
		if ($permission['can_view'] == 0 && $error == 1)
		{
			error_message('You are not authorised to view that forum, sorry!');
			
			include('footer.php');
			
			die();
		}
		
		else if ($permission['can_view'] == 0 && $error == 0)
		{
			return false;
		}
		
		return true;
	}
	
	if ($trying == 'maketopic')
	{
		$sql_permissions = "SELECT `can_topic` FROM `permissions` WHERE `forum_id` = {$forum_id} AND `group_id` = {$group_sql}";
		
		$query_permissions = mysql_query($sql_permissions) or die(mysql_error() . '<br />Sql: ' . $sql_permissions);
		
		$permission = mysql_fetch_array($query_permissions);
		
		if ($permission['can_topic'] == 0 && $error == 1)
		{
			error_message('You are not authorised to make new topics, sorry!');
			
			include('footer.php');
			
			die();
		}
		
		else if ($permission['can_topic'] == 0 && $error == 0)
		{
			return false;
		}
		
		return true;
	}
	
	if ($trying == 'reply')
	{
		$sql_permissions = "SELECT `can_reply` FROM `permissions` WHERE `forum_id` = {$forum_id} AND `group_id` = {$group_sql}";
		
		$query_permissions = mysql_query($sql_permissions) or die(mysql_error() . '<br />Sql: ' . $sql_permissions);
		
		$permission = mysql_fetch_array($query_permissions);
		
		if ($permission['can_reply'] == 0 && $error == 1)
		{
			error_message('You are not authorised to reply to that topic, sorry!');
			
			include('footer.php');
			
			die();
		}
		
		else if ($permission['can_reply'] == 0 && $error == 0)
		{
			return false;
		}
		
		return true;
	}
}

function recursive_category($category_id, $lines = "--")
{
	// Sort out the subcategorys
	$find_next_level = mysql_query('SELECT * FROM `forums` WHERE `parent` = "' . $category_id . '"');
        
	if (mysql_num_rows($find_next_level) > 0)
	{
		while ($get_next_level = mysql_fetch_array($find_next_level))
		{
			echo "<option value=\"{$get_next_level['fid']}\">{$lines}{$get_next_level['name']}</option>";
			
			$find_more = mysql_query('SELECT * FROM `forums` WHERE `parent` = "' . $get_next_level['fid'] . '"');
            
			if (mysql_num_rows($find_more) > 0)
			{                
				recursive_category($get_next_level['fid'], $lines."-");
			}
		}
	} 
} 
?>
